
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;

public class ChatClient implements Runnable{
	
	Socket iClient;
	
	String userName,serverName,server_msg;
	int portNo=2345;
	BufferedReader msgFromServer;
	DataOutputStream msgToServer;
	
	Thread iThread;
	
	ChatClientUI iClientUI;
	ArrayList iConversationRoomList,iConferenceRoomList;
	
	public ChatClient(ChatHandler iHandle){
		
		iClient=iHandle.getClientSocket();
		msgFromServer=iHandle.getInputStream();
		msgToServer=iHandle.getOutputStream();
		portNo=iHandle.getPortNo();
		serverName=iHandle.getServerName();
		userName=iHandle.getUserName();
		iThread=new Thread(this,"client");
		iConversationRoomList=new ArrayList();
		iThread.start();
	}
    
    public void run(){
    	while(iThread!=null){
    		try{
    			server_msg=msgFromServer.readLine();
    		}catch(IOException e){
 				System.out.println(e);
    		}

    		if(server_msg.startsWith("USERLIST")){
    			server_msg=server_msg.substring(8);
    			iClientUI=new ChatClientUI(this,server_msg);
    		}
    		if(server_msg.startsWith("NEWUSER")){
    			server_msg=server_msg.substring(8);
    			iClientUI.addUser(this,server_msg);
    		}
    		if(server_msg.startsWith("LOGGEDOUT")){
    			server_msg=server_msg.substring(9);
    			iClientUI.removeUser(this,server_msg);
    		}
    		if(server_msg.startsWith("MESSAGEFROM")){
    			String sender=server_msg.substring(12,server_msg.indexOf(":")-1);
    			room_message(sender,server_msg.substring(server_msg.indexOf(":")+2));
    		}
    	}
    }
    
    protected void send_Message(String msg){
    	try{
    		msgToServer.writeBytes(msg+"\r\n");
    	}catch(IOException e){
    		System.out.println(e);
    		log_out();
    	}
    }
    
    public  void log_out(){ 
    	if(iClient!=null){
    		send_Message("LOGGINGOUT "+userName);
    		try{
    			System.out.println("\n ߴ");
    			iThread=null;
    			iClient.close();
    		}catch(IOException e){
    			System.out.println(e);
    		}
    		iClient=null;
    		System.out.println("α׾ƿ");
    	}
    }
    
    public ChatRoomUI getRoom(String otherClient){
    	int roomNo=iConversationRoomList.size();
    	ChatRoomUI returnRoom=null,tempRoom;
    	for(int iCount=0;iCount<roomNo;iCount++){
    		tempRoom=(ChatRoomUI)iConversationRoomList.get(iCount);
    		if(tempRoom.receiver.equals(otherClient)){
    			returnRoom=tempRoom;
    		}
    	}
    	return(returnRoom);
    }
    
    public void removeRoom(String otherClient){
    	int roomNo=iConversationRoomList.size();
    	int remove_room=-1;
    	ChatRoomUI tempRoom=null;
    	for(int iCount=0;iCount<roomNo;iCount++){
    		tempRoom=(ChatRoomUI)iConversationRoomList.get(iCount);
    		if(tempRoom.receiver.equals(otherClient)){
    			remove_room=iCount;
    		}
    	}
    	iConversationRoomList.remove(remove_room);
    	iConversationRoomList.trimToSize();
    }
    
    public boolean roomExists(String otherClient){
    	ChatRoomUI room=getRoom(otherClient);
    	if(room!=null){
    		return true;
    	}
    	else return false;
    }
    public void room_message(String otherClient,String message){
    	if(roomExists(otherClient)){
    		ChatRoomUI room=getRoom(otherClient);
    		room.output.append("\n"+otherClient+" : "+message);
    	}
    	else{
    		ChatRoomUI room=new ChatRoomUI(this,otherClient);
    		iConversationRoomList.add(room);
    		if(!message.equals("")){
    			room.output.append("\n"+otherClient+" : "+message);
    		}
    		
    	}
    }
    
    public static void main(String args[]){
    	ClientLogin iChatLogin=new ClientLogin();
    }
}
