
import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;

public class ChatClientUI implements ActionListener,MouseListener{
	ChatClient iClient;
	
	JFrame frame;
	JLabel online;
	JList onlineList;
	JButton stopButton,exitButton;
	Image sook_icon;
	String userList;
	String onlineUsers[];
	
	public ChatClientUI(ChatClient client,String user_list){
		iClient=client;
		userList=user_list;
		onlineUsers=user_list.split(" ");
		
		frame=new JFrame("SM Messenger");
		frame.setLayout(null);
		frame.setBounds(0,0,200,530);
		frame.setResizable(false);
		
		sook_icon = Toolkit.getDefaultToolkit().getImage("./img/sm_mark.JPG");
		frame.setIconImage(sook_icon);
		online=new JLabel("¶");
		online.setBounds(20,20,100,25);
		frame.add(online);
		
		onlineList=new JList(onlineUsers);
		onlineList.setCellRenderer(new ClientListRenderer());
		onlineList.setBounds(10,50,170,380);
		onlineList.addMouseListener(this);
		frame.add(onlineList);
		
		stopButton=new JButton("α׾ƿ");
		stopButton.setBounds(8,450,87,30);
		stopButton.setForeground(Color.white);
		stopButton.setBackground(Color.DARK_GRAY);
		stopButton.addActionListener(this);
		frame.add(stopButton);
		
		exitButton=new JButton("");
		exitButton.setBounds(102,450,80,30);
		exitButton.setForeground(Color.white);
		exitButton.setBackground(Color.DARK_GRAY);
		exitButton.addActionListener(this);
		frame.add(exitButton);
		
		frame.addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					exit_iChatClient();
				}
			}
		);

		frame.setVisible(true);
	}	
		
	public void actionPerformed(ActionEvent e){
    	if(e.getSource()==stopButton){
    		iClient.log_out();
    		frame.dispose();
    		ClientLogin login=new ClientLogin();
    	}
    	if(e.getSource()==exitButton){
    		exit_iChatClient();
    	}
    }
    
    public void mouseClicked(MouseEvent e){
    	if(e.getClickCount()==2){
    		int index=onlineList.locationToIndex(e.getPoint());
    		iClient.room_message(onlineUsers[index],"");
    	}
    }
    public void mouseExited(MouseEvent e){}
    public void mouseEntered(MouseEvent e){}
    public void mouseReleased(MouseEvent e){}
    public void mousePressed(MouseEvent e){}
    
    public void exit_iChatClient(){
    	iClient.log_out();
    	frame.dispose();
    }
    
    public void addUser(ChatClient client,String new_user){
    	userList=userList+" "+new_user;
    	frame.dispose();
    	client.iClientUI=new ChatClientUI(iClient,userList);
    }
    
    public void removeUser(ChatClient client,String remove_user){
    	if(userList.equals(remove_user)){
    		userList="";
    	}
    	else if(userList.startsWith(remove_user)){
    		userList=userList.substring(remove_user.length());
    	}
    	else if(userList.endsWith(remove_user)){
    		userList=userList.substring(0,userList.indexOf(remove_user));
    	}
    	else{
    		userList.replace(remove_user,"");
    	}
    	frame.dispose();
    	client.iClientUI=new ChatClientUI(iClient,userList);
    }
}
