
import java.awt.Color;
import java.awt.Image;
import java.awt.TextArea;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class ChatRoomUI implements ActionListener,KeyListener{
	
	JFrame frame;
	JTextField userInput;
	TextArea output;
	JButton send;
	Image sook_icon,sook_logo;
	String name,receiver,currentMsg;
	ImagePanel sookPanel;
	JPanel panel;
	JLabel label;
	ChatClient client;
	
	public ChatRoomUI(ChatClient iClientOb,String forUser){
		client=iClientOb;
		name=client.userName;
		receiver=forUser;
		
		frame = new JFrame("ȭ");
		frame.setLayout(null);
		frame.setBounds(0,0,400,580);
		frame.setResizable(false);
		
		sook_icon = Toolkit.getDefaultToolkit().getImage("./img/sm_mark.JPG");
		sook_logo = Toolkit.getDefaultToolkit().getImage("./img/sm_logo.JPG");
		
		frame.setIconImage(sook_icon);

		label = new JLabel("ȭ : "+receiver);
		label.setBounds(15,10,380,30);
		label.setForeground(Color.blue);
		
		frame.add(label);
		
		output = new TextArea("",0,0,1);
		output.setBackground(Color.WHITE);
		output.setBounds(15,40,370,370);
		output.setEditable(false);
		frame.add(output);
		
		panel = new JPanel(null);
		panel.setBounds(70,420,260,65);
		panel.setBackground(Color.white);
		
		sookPanel = new ImagePanel(sook_logo);
		sookPanel.setBounds(0,0,260,65);
		
		panel.add(sookPanel);
		frame.add(panel);

		userInput = new JTextField("");
		userInput.setBounds(15,500,305,40);
		userInput.addKeyListener(this);
		frame.add(userInput);
		
		send=new JButton("");
		send.setBounds(325,500,60,40);
		send.setForeground(Color.white);
		send.setBackground(Color.DARK_GRAY);
		send.addActionListener(this);
		send.addKeyListener(this);
		frame.add(send);
		
		frame.addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					client.removeRoom(receiver);
					frame.dispose();
				}
			}
		);
		
		frame.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==send){
			send_message();
		}
	}
	
	public void keyPressed(KeyEvent e){
		if(e.getKeyChar()=='\n'){
			send_message();
		}
	}	
	public void keyReleased(KeyEvent e){}
	public void keyTyped(KeyEvent e){}
	
	public void send_message(){
		currentMsg=userInput.getText();
		client.send_Message("MESSAGETO "+receiver+" "+name+" : "+currentMsg);
		userInput.setText("");
		currentMsg="\n"+name+" : "+currentMsg;
		output.append(currentMsg);
	}
	
}
