
import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class ClientLogin implements ActionListener,KeyListener{
	Socket client;
	JFrame frame;
	Image sook_icon,sook_univ;
	JLabel lUserName,lServer,lport;
	JTextField getUserName,getServer,portText;
	JButton startButton,exitButton;
	ImagePanel sookPanel;
	JPanel panel;
	JLabel label;
	String userName,serverName,server_msg;
	int portNo=2345;
	BufferedReader msgFromServer;
	DataOutputStream msgToServer;
	
	ChatHandler handler;

	public ClientLogin() {
		frame=new JFrame("SM Messenger");
		frame.setLayout(null);
		frame.setBounds(300,50,240,580);
		frame.setResizable(false);
		
		sook_icon=Toolkit.getDefaultToolkit().getImage("./img/sm_mark.JPG");
		sook_univ = Toolkit.getDefaultToolkit().getImage("./img/sm_univ.JPG");
		
		frame.setIconImage(sook_icon);
		
		lUserName=new JLabel(" ");
		lUserName.setBounds(30,50,100,25);
		frame.add(lUserName);
		
		lServer=new JLabel("");
		lServer.setBounds(30,80,100,25);
		frame.add(lServer);
		
		lport=new JLabel("Ʈȣ");
		lport.setBounds(30,130,100,25);
		frame.add(lport);
		
		getUserName=new JTextField(15);
		getUserName.setBounds(100,50,90,25);
		getUserName.addKeyListener(this);
		frame.add(getUserName);
		
		getServer=new JTextField(16);
		getServer.setBounds(100,80,90,25);
		getServer.addKeyListener(this);
		frame.add(getServer);
		
		portText=new JTextField(5);
		portText.setBounds(100,130,50,25);
		portText.setText("2345");
		portText.addKeyListener(this);
		frame.add(portText);
		
		startButton=new JButton("α");
		startButton.setBounds(30,220,80,30);
		startButton.addActionListener(this);
		startButton.setForeground(Color.white);
		startButton.setBackground(Color.DARK_GRAY);
		startButton.addKeyListener(this);
		frame.add(startButton);
		
		exitButton=new JButton("");
		exitButton.setBounds(120,220,80,30);		
		exitButton.setForeground(Color.white);
		exitButton.setBackground(Color.DARK_GRAY);
		exitButton.addActionListener(this);
		frame.add(exitButton);
		
		panel = new JPanel(null);
		panel.setBounds(10,350,213,166);
		panel.setBackground(Color.white);
		
		sookPanel = new ImagePanel(sook_univ);
		sookPanel.setBounds(0,0,213,166);
		
		panel.add(sookPanel);
		frame.add(panel);
		
		
		frame.addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					exitChatClient();
				}
			}
		);
		frame.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e){
    	if(e.getSource()==startButton){
    		log_in();
    	}
    	if(e.getSource()==exitButton){
    		exitChatClient();
    	}
    }
    
    public void keyPressed(KeyEvent e){
    	if(e.getKeyChar()=='\n'){
    		log_in();
    	}
    }
    public void keyReleased(KeyEvent e){}
    public void keyTyped(KeyEvent e){}
	
	private void log_in(){
    	userName=getUserName.getText();
    	userName.trim();
    	if(userName.isEmpty()){
    		System.out.println("\n ̸ Էϼ.");
    		new DialogBox(frame," ̸"," ̸ Էϼ");
    		return;
    	}
    	else if(userName.contains(" ")){
    		System.out.println("\n  Է ּ.");
    		new DialogBox(frame," ̸"," Էּ");
    		return;
    	}
    	serverName=getServer.getText();
    	if(serverName.equals("")){
    		System.out.println("\nּҸ Էϼ");
    		new DialogBox(frame,"ּ","ּҸ Էϼ");
    		return;
    	}
    	try{
    		portNo=Integer.parseInt(portText.getText());
    	}catch(NumberFormatException e){
    		System.out.println(e);
    	}
    	try{
    		System.out.println("\n ...");
    		client=new Socket(serverName,portNo);
    		msgFromServer=new BufferedReader(new InputStreamReader(new DataInputStream(client.getInputStream())));
    		msgToServer=new DataOutputStream(client.getOutputStream());	
    	}catch(IOException e){
    		new DialogBox(frame,"ڸ ã  ϴ.","Ȯ /Ʈ Էϼ");
    		System.out.println("\n̸ Ʈȣ ٸϴ.");
    	}
    	send_Message("NEWCLIENT "+userName);
		try{
			server_msg=msgFromServer.readLine();
		}catch(IOException e){
			System.out.println(e);
		}
		if(server_msg.equals("USEREXISTS")){
			System.out.println("\n̹ ִ ̸Դϴ. ٸ̸ Էϼ.");
			new DialogBox(frame,"̸ ߺ","ٸ ̸ Էϼ");
			return;
		}
		if(server_msg.equals("WELCOME")){
			handler=new ChatHandler();
			handler.setClientSocket(client);
			handler.setInputStream(msgFromServer);
			handler.setOutputStream(msgToServer);
			handler.setPortNo(portNo);
			handler.setServerName(serverName);
			handler.setUserName(userName);
			System.out.println("\nȯմϴ.");
			ChatClient client = new ChatClient(handler);
			frame.dispose();
		}
    }
    
    public void exitChatClient(){
    	frame.dispose();
    	System.out.println("\nȳ ");
    	System.exit(0);
    }
    
    private void send_Message(String msg){
    	try{
    		msgToServer.writeBytes(msg+"\r\n");
    	}catch(IOException e){
    		System.out.println(e);   	
    	}
    }
    
	public static void main(String[] args) {
		ClientLogin iChat=new ClientLogin();
	}
}
