
import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class ChatServer implements Runnable,ActionListener,KeyListener{
	
	// Ʈ   
	JFrame frame;
	JPanel panel;
	JTextField portText;
	JButton startButton,stopButton,exitButton;
	JLabel lname,lport,lstate;
	Image sook_icon;
	
	boolean isServerRunning=false;
	ServerSocket socketSer;
	int portNum;
	
	Thread mainThread;
	ArrayList iClientList;
	
	// 
	public ChatServer(){
		
		frame = new JFrame("ä ");
		frame.setLayout(null);
		frame.setBounds(0,0,190,290);
		frame.setResizable(false);
		frame.addKeyListener(this);
		
		sook_icon=Toolkit.getDefaultToolkit().getImage("./img/sm_mark.JPG");
		frame.setIconImage(sook_icon);
		
		lport = new JLabel("Ʈ ȣ :");
		lport.setBounds(40,20,300,30);
		frame.add(lport);
		
		lstate = new JLabel(" ");
		lstate.setBounds(60,220,80,40);
		frame.add(lstate);
		
		portText = new JTextField(5); // Է â
		portText.setText("2345");
		portText.setBounds(110,20,35,25);
		portText.addKeyListener(this);
		frame.add(portText);
		
		// ,  ư 
		startButton = new JButton("START");
		startButton.setBounds(50,65,80,40);
		startButton.addActionListener(this);
		startButton.addKeyListener(this);
		startButton.setForeground(Color.white);
		startButton.setBackground(Color.DARK_GRAY);
		frame.add(startButton);
		
		stopButton = new JButton("STOP");
		stopButton.setBounds(50,110,80,40);
		stopButton.addActionListener(this);
		stopButton.addKeyListener(this);
		stopButton.setForeground(Color.white);
		stopButton.setBackground(Color.DARK_GRAY);
		frame.add(stopButton);
		
		exitButton = new JButton("EXIT");
		exitButton.setBounds(50,155,80,40);
		exitButton.addActionListener(this);
		exitButton.setForeground(Color.white);
		exitButton.setBackground(Color.DARK_GRAY);
		frame.add(exitButton);
		
		frame.addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					exit_socketSer();	//  â 
				}
			}
		);
		frame.setVisible(true);
	}
	
	// ̺Ʈ 
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==startButton){
			start_socketSer();
			lstate.setText(" ");
		}
		if(e.getSource()==stopButton){
			stop_socketSer();
			lstate.setText(" ߴ");
		}	
		if(e.getSource()==exitButton){
			exit_socketSer();
		}
	}
	
	// Ű ̺Ʈ 
	public void keyPressed(KeyEvent e){
		if(e.getKeyChar()=='\n' && !isServerRunning){
			start_socketSer();
		}
		else if(e.getKeyChar()=='\n' && isServerRunning){
			stop_socketSer();
		}
	}
	public void keyTyped(KeyEvent e){}
	public void keyReleased(KeyEvent e){}
	
	
	//    
	protected void start_socketSer(){
		try{
			portNum=Integer.parseInt(portText.getText()); // Ʈȣ 
			
		}catch(NumberFormatException e){
			System.out.println("\n"+e+"\nStarting default port : 2345");
			portNum=2345;
		}
		
		try{
			socketSer=new ServerSocket(portNum);	//   
			isServerRunning=true;
			
			System.out.println("\nServer running Ʈȣ: "+portNum);			
			portText.setEnabled(false);
			
			iClientList=new ArrayList();
			
			//  , 
			mainThread=new Thread(this,"Chatting Server");
			mainThread.start();
			
		}catch(IOException e){
			System.out.println("\n"+e);
			System.out.println("Error!");
		}
	}
	//  ޼ҵ
	public void run() {
		while(mainThread!=null){
			try{
				Socket newClient=socketSer.accept();	// ο Ŭ̾Ʈ ޾Ƶ
				ChatHandler newCHandle=new ChatHandler(this,newClient);
				Thread.sleep(1000);
				
			}catch(InterruptedException e){
			}catch(IOException e){
			}
		}
	}
	
	//   ߴ
	protected void stop_socketSer(){
		
		if(socketSer!=null){
			try{	
				socketSer.close();
				socketSer=null;
				isServerRunning=false;
				iClientList=null;
				System.out.println("\nServer closed: "+portNum);
				
				mainThread=null;
			}catch(IOException e){
				System.out.println("\n"+e);
			}
		}
	}
	
	// 
	protected void exit_socketSer(){
		System.out.println("\nquit");
		stop_socketSer();
		frame.dispose();
		System.exit(0);
	}
	
	// Ŭ̾Ʈ ü  
	protected ChatClient getClient(String clientName){
		
		ChatClient returnClient = null;
		ChatClient tempClient;
		int listSize = iClientList.size();
		
		for(int i = 0; i < listSize; i++){
			tempClient =(ChatClient)iClientList.get(i);
			
			if(clientName.equalsIgnoreCase(tempClient.getClientName())){
				returnClient = tempClient;
				break;
			}
		}
		return(returnClient);
	}
	
	protected Socket getClientSocket(String clientName){
		ChatClient client=getClient(clientName);
		return(client.getClientSocket());
	}
	
	// Ŭ̾Ʈ  
	protected boolean clientExists(String clientName){
		if(getClient(clientName)!=null){
			return true;
		}else{
			return false;
		}
	}
	
	// Ŭ̾Ʈ ߰
	public void addClient(Socket clientSock, String clientName){
		if(clientExists(clientName)){
			unicast(clientSock,"USEREXISTS");
			return;
		}
		else unicast(clientSock,"WELCOME");
		System.out.println("\n"+clientName+" αϼ˽ϴ.");
		
		// Ŭ̾Ʈ ü 
		ChatClient client = new ChatClient(clientSock,clientName);
		ChatClient tempClient;
		
		iClientList.add(client);	// Ŭ̾Ʈ ߰
		
		StringBuffer clientListBuf = new StringBuffer("USERLIST");
		String newClient = "NEWUSER "+clientName;	// ο Ŭ̾Ʈ
		
		int listSize = iClientList.size();
		for(int i = 0; i < listSize; i++){
			tempClient = (ChatClient)iClientList.get(i);
			
			if(!clientName.equals(tempClient.getClientName())){
				unicast(tempClient.getClientSocket(),newClient);
				clientListBuf.append(" " + tempClient.getClientName());
			}	
		}
		unicast(clientSock,clientListBuf.toString());
	}
	
	//Ŭ̾Ʈ 
	public void removeClient(String clientName){		
		
		ChatClient client = getClient(clientName);
		Socket clientSock = client.getClientSocket();

		iClientList.remove(client);		// Ŭ̾Ʈ Ʈ 
		iClientList.trimToSize();
		
		try{
			clientSock.close();			//  ݱ
			System.out.println("\n"+clientName+" α׾ƿ ϼ̽ϴ.");
		}catch(IOException e){
			System.out.println(e +"\nError!");
		}
		
		clientSock = null;
		broadcast("LOGGEDOUT "+clientName);
	}
	
	// ޽ write
	protected void unicast(Socket clientSocket,String message){
		try {
				new DataOutputStream(clientSocket.getOutputStream()).write(new String(message+"\r\n").getBytes());			
		}catch(IOException e){}
	}
	
	// ε ĳƮ
	private void broadcast(String message){
		ChatClient client;
		int listSize = iClientList.size();
		
		for(int i = 0; i < listSize; i++){
			client = (ChatClient)iClientList.get(i);
			unicast(client.getClientSocket(),message);
		}
	}
    
    public static void main(String[] args) {
    	new ChatServer();
    }
}